/*
 * Segment 5 Intelligente Analyseverfahren, SWE 5.5 Funktionen Ganglinie
 * Copyright (C) 2011-2015 BitCtrl Systems GmbH
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.iav.gllib.gllib.domain;

/**
 * Repräsentation eines Datensatzes der Attributgruppe "atg.verkehrsDatenKurzZeitMq".
 * 
 * @author BitCtrl Systems GmbH, Uwe Peuker
 */
public final class VerkehrsDatenKurzZeitMq {

    private boolean valid;
    private long zeitstempel;

    private Double vLkw;
    private Double vPkw;
    private Double qKfz;
    private Double qLkw;

    private VerkehrsDatenKurzZeitMq(long zeitStempel) {
        this.zeitstempel = zeitStempel;
    }

    private VerkehrsDatenKurzZeitMq(long zeitStempel, Double vLkw, Double vPkw, Double qKfz, Double qLkw) {
        valid = true;
        this.zeitstempel = zeitStempel;
        this.vLkw = vLkw;
        this.vPkw = vPkw;
        this.qKfz = qKfz;
        this.qLkw = qLkw;
    }

    public static VerkehrsDatenKurzZeitMq invalid(long zeitStempel) {
        return new VerkehrsDatenKurzZeitMq(zeitStempel);
    }

    public static VerkehrsDatenKurzZeitMq of(long zeitStempel, Double vLkw, Double vPkw, Double qKfz, Double qLkw) {
        return new VerkehrsDatenKurzZeitMq(zeitStempel, vLkw, vPkw, qKfz, qLkw);
    }

    public boolean isValid() {
        return valid;
    }

    public long getZeitstempel() {
        return zeitstempel;
    }

    public Double getVLkw() {
        return vLkw;
    }

    public Double getVPkw() {
        return vPkw;
    }

    public Double getQLkw() {
        return qLkw;
    }

    public Double getQKfz() {
        return qKfz;
    }
}
