/*
 * Segment 5 Intelligente Analyseverfahren, SWE 5.5 Funktionen Ganglinie
 * Copyright (C) 2011-2015 BitCtrl Systems GmbH
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.iav.gllib.gllib.domain.comm;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

import de.bsvrz.iav.gllib.gllib.domain.GanglinienAnfrager;

/**
 * Repräsentiert eine einzelne Anfrage einer Anfragenachricht an die
 * Ganglinienprognose.
 *
 * @author BitCtrl Systems GmbH, Schumann
 */
public class GlProgAnfrage {

    private final GanglinienAnfrager anfrager;
    private final String absenderZeichen;

    private final List<PrognoseAnfrage> anfragen;

    public GlProgAnfrage(GanglinienAnfrager anfrager, String absenderZeichen, List<PrognoseAnfrage> anfragen) {
        this.anfrager = anfrager;
        this.absenderZeichen = Objects.requireNonNull(absenderZeichen);
        this.anfragen = new ArrayList<>(Objects.requireNonNull(anfragen));
    }

    public GanglinienAnfrager getAnfrager() {
        return anfrager;
    }

    public String getAbsenderZeichen() {
        return absenderZeichen;
    }

    public List<PrognoseAnfrage> getAnfragen() {
        return anfragen;
    }

    @Override
    public String toString() {
        return "GlProgAnfrage [anfrager=" + anfrager + ", absenderZeichen=" + absenderZeichen + ", anfragen="
                + anfragen.size() + "]";
    }
}
