Versionsverlauf
===============

## [Noch nicht veröffentlicht]

## [Version 4.0.0]

### Allgemeine Hinweise

Die Ganglinienbibliothek liegt in einer neuen, nicht abwärtskompatiblen Version vor.
Es wurden die beiden Versionen (Legacy-Server-Version 2 und Plugin-Version 3) zusammengeführt. 
Die neue Version 4 kann als Serverversion verwendet werden und wird als OSGI-Bundle auf der allgemeinen NERZ-Updateseite für die Einbindung ins Rahmenwerk bereitgestellt.

Zum Einsatz der SWE wird der Konfigurationsbereich "kb.tmGanglinienGlobal" in der aktuellen Version 12 benötigt.

Da die Schnittstellen nicht abwärtskompatibel sind, müssen weitere SWE aktualisiert werden:

- Ganglinien-Prognose ab Version 3
- Ganglinien-Lernen   ab Version 3
- Stauverlaufsanalyse ab Version 2
- Baustellensimulation ab Version 3

Weitere Anwender der Ganglinienbibliothek sind aus dem NERZ-Repository momentan nicht bekannt. Die Low-Level-Konfiguration über die Anfrage-Antwort-Attributgruppen funktioniert auch unabhängig von der Bibliothek.

Die Einstiegspunkte für den Zugriff auf den Ganglinienspeicher oder die Ganglinienprognose   sind:

````
public interface GanglinienPrognoseClient {

    void sendeAnfrage(List<PrognoseAnfrage> anfragen, Consumer<GlProgAntwort> antwortEmpfangen);
    void sendeAnfrage(String kennung, List<PrognoseAnfrage> anfragen, Consumer<GlProgAntwort> antwortEmpfangen);

    void sendeAnfrage(List<PrognoseAnfrage> anfragen, Consumer<GlProgAntwort> antwortEmpfangen,
            Duration timeout, Runnable timeoutErreicht)
    void sendeAnfrage(String kennung, List<PrognoseAnfrage> anfragen, Consumer<GlProgAntwort> antwortEmpfangen,
            Duration timeout, Runnable timeoutErreicht);

    GlProgAntwort sendeAnfrage(List<PrognoseAnfrage> anfragen, Duration timeout) throws TimeoutException
    GlProgAntwort sendeAnfrage(String kennung, List<PrognoseAnfrage> anfragen, Duration timeout)
            throws TimeoutException;
}

````

für die Prognose und

````
public interface GanglinienSpeicherClient {

    GanglinienAnfrager getAnfrager();
    String getAnfrageId();

    List<MqGanglinie> liesGanglinien(GlLesenAnfrage anfrage, Duration timeout)
            throws TimeoutException, GanglinienException;

    void liesGanglinien(GlLesenAnfrage anfrage, Consumer<GlSpeicherAntwort> antwort,
            Consumer<GlSpeicherFehlerAntwort> fehlerAntwort);

    void liesGanglinien(GlLesenAnfrage anfrage, Consumer<GlSpeicherAntwort> speicherAntwort,
            Consumer<GlSpeicherFehlerAntwort> speicherFehlerAntwort, Duration timeout);

    void schreibeGanglinien(GlSchreibenAnfrage anfrage, Consumer<GlSpeicherAntwort> antwort,
            Consumer<GlSpeicherFehlerAntwort> fehlerAntwort);

    void schreibeGanglinien(GlSchreibenAnfrage anfrage, Consumer<GlSpeicherAntwort> antwort,
            Consumer<GlSpeicherFehlerAntwort> fehlerAntwort, Duration timeout);

    void loescheGanglinien(GlLoeschenAnfrage anfrage, Consumer<GlSpeicherAntwort> antwort,
            Consumer<GlSpeicherFehlerAntwort> fehlerAntwort);

    void loescheGanglinien(GlLoeschenAnfrage anfrage, Consumer<GlSpeicherAntwort> antwort,
            Consumer<GlSpeicherFehlerAntwort> fehlerAntwort, Duration timeout);

    List<MqGanglinie> erzeugeGanglinien(GlAnlegenAnfrage anfrage, Duration timeout)
            throws TimeoutException, GanglinienException;

    void erzeugeGanglinien(GlAnlegenAnfrage anfrage, Consumer<GlSpeicherAntwort> antwort,
            Consumer<GlSpeicherFehlerAntwort> fehlerAntwort);

    void erzeugeGanglinien(GlAnlegenAnfrage anfrage, Consumer<GlSpeicherAntwort> antwort,
            Consumer<GlSpeicherFehlerAntwort> fehlerAntwort, Duration timeout);

    List<MqGanglinie> aktualisiereGanglinien(GlAktualisierenAnfrage anfrage, Duration timeout)
            throws TimeoutException, GanglinienException;

    void aktualisiereGanglinien(GlAktualisierenAnfrage anfrage, Consumer<GlSpeicherAntwort> antwort,
            Consumer<GlSpeicherFehlerAntwort> fehlerAntwort);

    void aktualisiereGanglinien(GlAktualisierenAnfrage anfrage, Consumer<GlSpeicherAntwort> antwort,
            Consumer<GlSpeicherFehlerAntwort> fehlerAntwort, Duration timeout);
}
````

für den Ganglinienspeicher. Die Funktionen ermöglichen den synchronen oder asynchronen Abruf sowie die optionale Angabe einer eigenen Anfrage-Kennung.

Die Implementierungen sind die Klassen:

- de.bsvrz.iav.gllib.gllib.portals.DavGanglinienprognose bzw.
- de.bsvrz.iav.gllib.gllib.portals.DavGanglinienSpeicher
 

### Bugfixes aus vorherigen Versionen

- das Attribut "Aktualisierungsschwelle" innerhalb einer Ganglinien-Prognose-Anfrage führte zu 
  einer IllegalStateException, wenn für den Wert einer der Zustände, die nicht im Wertebereich
  liegen empfangen wurde

## [Version 2.3.7]

- Hibernate-Version aktualisiert, wegen Problemen der eingebetten javassist-Version mit Java 8
  (Datenbankverbindung konnte nicht etabliewrt werden).
- Zugriff auf die Stützstellen einer Ganglinie optimiert

## [Version 2.3.6]

- Persistence-Definition für die Gangliniendatenbank wiederhergestellt
  siehe: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.iav.gllib/issues/3

## [Version 2.3.5]

- Derby und Hibernate-Entitymanager ergänzt, Build durch FTB und Bereitstellung auf NERZ-Repositories

## [Version 2.3.4]

- NERZ: Umstellung auf Gradle, Build durch FTB und Bereitstellung auf NERZ-Repositories

## Version 2.3.3

- Umbau auf Gradle-Build

## Version 2.3.2

- Bugfix: Löschen von Ganglinien über die Anfrage-Schnittstelle wurde korrigiert 

## Version 2.3.1

- Ganglinienliste MQ in Derby wird angelegt, wenn sie noch nicht existiert und über die Datenverteiler-Schnittstelle
  angelegt werden soll

## Version 2.3.0

- Umstellung auf Java 8 und UTF-8

## Version 2.2.0

  - Umstellung auf Maven-Build

## Version 2.1.2

  - Hibernate-Entity-Manager wurde geschlossen und dann wiederverwendet (internal #2849)

## Version 2.1.1

  - Bei Abfrage von historischen Ganglinien konnte die SWE GlLernen abstürzen.
    (Mantis #2102)
  - Loggausgaben beim Unit-Test werden wieder angezeigt.
  - Überarbeitung der JUnit-Tests damit sie nach DAF-Upgrade wieder wie gewohnt
    funtionieren.

## Version 2.1.0

  - Betriebsmeldungen um Systemobjekt in ID ergänzen, wenn sinnvoll.
    (Mantis #2092)
  - Quelltext kompatibler mit Java 6 gemacht.

## Version 2.0.2

  - Speicherung der Ganglinien in Datenbank optimiert

## Version 2.0.0

  - Umstellung der Ganglinienspeicherung von der Behandlung als Parameter
    (atg.ganglinie) auf eine separate Speicherung in einer Derby DB.
  - Bereitstellung einer Datenverteiler-Schnittstelle für das Lesen und
    Schreiben von Ganglinien durch andere Applikationen
  - Verringerung der Stützstellenanzahl. Es ist Pro Approximationsverfahren per
    Kommdozeilenparameter einstellbar, welcher Aspekt von
    atg.verkehrsDatenKurzMq verwendet werden soll.
  - Vermeidung von Datenlücken. Die Verschmelzungsregeln des Ganglinienlernens
    wurde derart geändert:
    Alt: (Datenlücke + keine Datenlücke = Datenlücke),
    Neu: (Datenlücke + keine Datenlücke = keine Datenlücke)

## Version 1.3.0

  - Betriebsinformation und Prüfprozedur liegen jetzt im Zustand "akzeptiert"
    vor.

## Version 1.2.1

  - Betriebsinformation aktualisiert.

## Version 1.2.0

  - Anpassung an überarbeitetet Funktionsbibliothek de.bsvrz.sys.funclib.bitctrl
  - Pattern-Matching überarbeitet
  - Berechnung der Approximation durch B-Spline extrem beschleunigt
  - Prüfprozedur und Prüfprotokoll in Release aufgenommen
  - Betriebsinformation in Release aufgenommen

## Version 1.1.0

  - Umstellung auf neue Paketstruktur.
  - Erweiterung des Funktionsumfangs für SWE 5.1 und 5.3.

## Version 1.0.0

  - Erste Auslieferung

[Noch nicht veröffentlicht]: https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.iav.gllib/compare/v2.3.7...HEAD
[Version 2.3.7]: 
https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.iav.gllib/compare/v2.3.6...v2.3.7
[Version 2.3.6]: 
https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.iav.gllib/compare/v2.3.5...v2.3.6
[Version 2.3.5]: 
https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.iav.gllib/compare/v2.3.4...v2.3.5
[Version 2.3.4]: 
https://gitlab.nerz-ev.de/ERZ/SWE_de.bsvrz.iav.gllib/compare/v2.3.3...v2.3.4

