/*
 * Segment 5 Intelligente Analyseverfahren, SWE 5.5 Funktionen Ganglinie
 * Copyright (C) 2011-2015 BitCtrl Systems GmbH
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.
 *
 * Contact Information:
 * BitCtrl Systems GmbH
 * Weißenfelser Straße 67
 * 04229 Leipzig
 * Phone: +49 341-490670
 * mailto: info@bitctrl.de
 */

package de.bsvrz.iav.gllib.gllib.domain;

import java.util.Collections;
import java.util.List;

/**
 * Antwort vom Ereigniskalender, die die Liste der Ereigniswechsel in einem
 * angefragten Zeitraum enthält.
 * 
 * @author BitCtrl Systems GmbH, Uwe Peuker
 */
public class EreignisKalenderAntwort {

    private String absenderZeichen;
    private List<ZustandsWechsel> zustandsWechsel;

    public EreignisKalenderAntwort(String absenderzeichen, List<ZustandsWechsel> zustandsWechsel) {
        this.absenderZeichen = absenderzeichen;
        this.zustandsWechsel = Collections.unmodifiableList(zustandsWechsel);
    }

    public String getAbsenderZeichen() {
        return absenderZeichen;
    }

    public List<ZustandsWechsel> getZustandsWechsel() {
        return zustandsWechsel;
    }
}
